package com.awginc.beanio.test;

import javax.batch.api.chunk.ItemProcessor;

import org.apache.log4j.Logger;

public class GroupTestEnhanceHdrProcessor implements ItemProcessor {
	
	@Override
	public Object processItem(Object arg0) throws Exception {
		GroupTestEnhanceLnIn lineIn = (GroupTestEnhanceLnIn) arg0;
		
		GroupTestEnhanceLnOut lineOut = new GroupTestEnhanceLnOut();
		lineOut.setFirstName(lineIn.getFirstName());
		lineOut.setMiddleInitial(lineIn.getMiddleInitial());
		lineOut.setLastName(lineIn.getLastName());
		
		if (lineIn.getFirstName().equalsIgnoreCase("john")) {
			lineOut.setHonorific("Mr.");
		} else {
			lineOut.setHonorific("Mrs.");
		}
		
		if (createHeaders) {
			GroupTestEnhanceHdr header = new GroupTestEnhanceHdr();
			
			GroupTestEnhanceHdrLn1 hdr1 = new GroupTestEnhanceHdrLn1();
			hdr1.setDept("IT");
			
			GroupTestEnhanceHdrLn2 hdr2 = new GroupTestEnhanceHdrLn2();
			hdr2.setLine("header line 2");
			
			header.setLine1(hdr1);
			header.setLine2(hdr2);
			header.setLine(lineOut);
			
			createHeaders = false;
			log.info("Building headers and line");
			
			return header;
		} else {
			log.info("Building just line");
			
			return lineOut;
		}
	}

	private boolean createHeaders = true;
	private final Logger log = Logger.getLogger(this.getClass().getName());
}
